

//*****************************************************************************
//	   Adams-Bashforth-Moulton@(12)ɂ鑾zn̂m̐ϕvO(adams)
//       ver. 1.0   2015/05/29   by takesako@mrj.biglobe		
//*****************************************************************************

//@̃vO͈ȉ̕/\[XQlɂĂ܂B
//@EuV̂̋OvZv꒘AV(1992)
//@@@т̃\tg/\[X@lbc(p290-p295)
//    @ (ϐ/z񖼓̂܂܎gĂ܂)
//@EuV(f/)̈ʒuZyї\̌vZ\tg/\[X mhodv@
//@@@(V3.21 1997/11/03)@by m[oX 
//@@@(Adams-Bashforth-Moulton@(12)NIPEڐA܂B)
//@Eup\RŌV̂̓vJHAGRqAnl(1992)
//  EuEXPLANATORY SUPPLEMENT to the ASTRONOMICAL ALMANACv
//@@@@U.S.NAVAL OBSERVATORY, UVLERSITY SCIENCE BOOKS(1992)
//     @(DE200̏lyьvZ̉)
//@EuThe Planetary and Lunar Ephemerides DE430 and DE431v
//   @@William M. Folkner,* James G. Williams, Dale H. Boggs,
//	 @  Ryan S. Park, and Petr Kuchynka(2014/02/15)
//     @(f̏l͂̕gpĂ܂B)
//

#include <math.h>
#include <stdio.h>
#include <time.h>

#define MULT(a,b) (a[1]*b[1]+a[2]*b[2]+a[3]*b[3]) // xNg̓όvZ̒`
#define MAXN   16         //ϕV̐̒`@16̏ꍇz`(10)++f5
#define MAX_NI 16         //ϕV̐̒`
#define NIORD  12         //ϕ
#define NIDAY (NIORD+4)   //ϕ+[NGA
#define ADAMS  20
#define NISTP  8

//Tu[`̒`
void CDINI_DE431(double *EPOCH,double A[MAXN][4],double V[MAXN][4],double GMASS[MAXN], int NBODY );// f̏l`[`
void Minor_Planet(double MinorPlanet[67][8]);// f̏l`[`
void PERN(int NBODY, int I,double GMASS[MAXN] ,double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4]);//N̐ϕ̃[`
void ni_Runge_Kutta_exec(double DAY,double EPOCH,int NBODY,double GMASS[MAXN] ,double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4]);//QNb^@ɏlvZ[`
void ni_Adams_init(double APcf[ADAMS], double ACcf[ADAMS] );//	A_X̐lϕ@W̌vZ
void ni_Predict_Adams(double h,int p,double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double APcf[ADAMS] );//	A_X̐lϕ@(\)
void ni_Correct_Adams(double h,int p,double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double ACcf[ADAMS]);//	A_X̐lϕ@(C)
int ni_Adams_exec(double t,int p,int NBODY,double GMASS[MAXN],double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double APcf[ADAMS],double ACcf[ADAMS]);//A_X̐lϕ@^s 
void Calendar( double juday, double *year,double *month,double *day,double *hour,int LST,double longitude);//̌vZ  

FILE  *fptr,*optr,*ftp;


void main(void)
{
	double GMASS[MAXN],PER[NIDAY][MAXN][4],CD[NIDAY][MAXN][4],VL[NIDAY][MAXN][4];
	double A[MAXN][4],V[MAXN][4],AA[MAXN][4],VV[MAXN][4];
	double EPOCH,DAY,TEPOCH;
	double	SFLDAY,B,DayMax;
	int 	I,NBODY,M,N;
	int p;
	double APcf[ADAMS], ACcf[ADAMS];
 	double year,month,day,hour, longitude=0.0;
	int LST=0;
	time_t start_time,end_time,now;//Ԍvp


	 start_time= time(&now);//sԌvJn

	printf("\n Adams-Bashforth-Moulton@(12)ɂ鑾zn̂m̐ϕJn܂B\n\n");

//  vZʂރt@C(eLXg)I[v
	ftp= fopen ("data.csv","wt");

	NBODY=MAXN-1;

//	z̏;
	for ( M=0; M<=NBODY; M++){
		for ( N=0; N<=3; N++){
			for (I=0; I<=NIDAY-1; I++){
				PER   [I][M][N]=0.0;
				CD    [I][M][N]=0.0;
				VL    [I][M][N]=0.0;
				AA[M][N]       =0.0;
				VV[M][N]       =0.0;
			}
		}
	}

// vZ̕8Xebv̓`B@+̏ꍇlOiB-͌ށB
	B=4.0;//B=-4̏ꍇ4/NISTEP(8)=0.5XebvŌvZB0.125XebvŌvZꍇB=-1.0ƂB

//	vZSTEP(Ԋu)̌vZ(B=4.0DAY=0.5BB=1.0DAY=0.125B	)
	DAY=B/(double)NISTP;

//@vZ̓(l̓t̓)
	DayMax=365.25*100.0;
//	DayMax=1000.0;

//  t@Cւ̏݊Ԋu
	SFLDAY=500.0;

//	zEfȄl̒`
	CDINI_DE431( &EPOCH, A, V,GMASS,NBODY);

//  lvZzɑ
	for ( M=0; M<=NBODY; M++){
		for ( N=1; N<=3; N++){
			CD[0][M][N]=A[M][N];
			VL[0][M][N]=V[M][N];
		}
	}

//	l̓tTEPOCHɊi[
	TEPOCH=EPOCH;

//	A_Xlϕ@@W̌vZ
	ni_Adams_init( APcf, ACcf );

//@lϕƂ͋t12Xebv(p=1`12)̒lQNb^ŌvZB
	ni_Runge_Kutta_exec( (-1.0)*DAY, EPOCH, NBODY, GMASS , PER, CD, VL);//QNb^@ɂN̐ϕ̏ݒ胋[`

//	p (0`15)݂͌̔žvZ|CgB
	p=0;

	while(1){

//	***  I(SFLDAY)Ƀt@Cɏރ[`***
	if(fmod((EPOCH-2440400.5),SFLDAY) == 0.0) {			
		Calendar( EPOCH, &year,&month,&day,&hour,0,0);
		printf     ("Position on %5.0f/%2.0f/%2.0f: JD= %10.3f ; Adams, step= %6.3f day\n", year,month,day,EPOCH,DAY);
		fprintf(ftp,"Position on %5.0f/%2.0f/%2.0f: JD= %10.3f ; Adams, step= %6.3f day\n", year,month,day,EPOCH,DAY);
	for( M=0; M<=15; M++){
//		printf(" %2d, %20.15f, %20.15f, %20.15f, \n",p, CD [p][M][1], CD [p][M][2], CD [p][M][3]);//ʒu
//		printf(" %2d, %20.15f, %20.15f, %20.15f, \n",p, VL [p][M][1], VL [p][M][2], VL [p][M][3]);//x
//		printf(" %2d, %20.15f, %20.15f, %20.15f, \n",p, PER[p][M][1], PER[p][M][2], PER[p][M][3]);//x
		fprintf(ftp," %2d, %20.15f, %20.15f, %20.15f, \n",M, CD [p][M][1], CD [p][M][2], CD [p][M][3]);//ʒu
//		fprintf(ftp," %2d, %20.15f, %20.15f, %20.15f, \n",I, VL [p][M][1], VL [p][M][2], VL [p][M][3]);//x
//		fprintf(ftp," %2d, %20.15f, %20.15f, %20.15f, \n",I, PER[p][M][1], PER[p][M][2], PER[p][M][3]);//x
		}
	}

//	***  I(SFLDAY)Ƀt@Cɏރ[`(܂) ***

	// 8STEP̒lAdams-Bashforth-Moulton@ŌvZB
	// ŏP=0ɏlAQNb^P=1`12܂ŋt12STEP̌vZlĂB
	// ŏp=0ni_Adams_exec()̌vZŁAP=15`P=88Xebv̌vZlP=8ŕԂĂB
	// @p=8ni_Adams_exec()̌vZŁAP= 7`P=08Xebv̌vZlP=0ŕԂĂB
	// ȍ~̌JԂB

	p=ni_Adams_exec( B, p, NBODY, GMASS, PER, CD, VL, APcf, ACcf);	 

//	Bɐi
	EPOCH=EPOCH+B;//BWSTEPŌvZĂB

//	ȉ̏Ń[v𔲂
	if(B>0)if(EPOCH>TEPOCH+DayMax) break;
	if(B<0)if(EPOCH<TEPOCH-DayMax) break;

	}


	//****************************************

	fclose(ftp);

	end_time= time(&now);//I
    printf("\n vOs [%d SEC] \n\n", end_time-start_time);//sԂ̕\
}

//****************************************************************
// f̏lݒ@DE430/431̒`ɂ
// IPN Progress Report 42-196 February 15, 2014
// The Planetary and Lunar Ephemerides DE430 and DE431
//****************************************************************
	void CDINI_DE431(double *EPOCH,double A[MAXN][4],double V[MAXN][4],double GMASS[MAXN], int NBODY )
{
	int M,N;
	double GAUSS,GAUSS2,AMASS[MAXN];
	double MinorPlanet[67][8];

	*EPOCH=2440400.5e0;  // June 28,1969

//	Sun
	AMASS[ 0]=1.0/1.000000;
	A[0][1]=  0.00450250878464055477;A[0][2]=  0.00076707642709100705;A[0][3]= 0.00026605791776697764;
	V[0][1]= -0.00000035174953607552;V[0][2]=  0.00000517762640983341;V[0][3]= 0.00000222910217891203;
//	Mercury
	AMASS[ 1]=1.0/6023682.155592;
	A[1][1]=  0.36176271656028195477;A[1][2]= -0.09078197215676599295;A[1][3]=-0.08571497256275117236;
	V[1][1]=  0.00336749397200575848;V[1][2]=  0.02489452055768343341;V[1][3]= 0.01294630040970409203;
//	Venus
	AMASS[ 2]=1.0/408523.718658;
	A[2][1]=  0.61275194083507215477;A[2][2]= -0.34836536903362219295;A[2][3]=-0.19527828667594382236;
	V[2][1]=  0.01095206842352823448;V[2][2]=  0.01561768426786768341;V[2][3]= 0.00633110570297786403;
//	Earth (DE431t@C)
	AMASS[ 3]=1.0/332946.048834;
	A[3][1]=  1.205272339283337300e-001;A[3][2]= -9.258142388494053900e-001;A[3][3]= -4.015270155762981600e-001; 
	V[3][1]=  1.680396477807132400e-002;V[3][2]= 1.750343791001871300e-003 ;V[3][3]= 7.592425273900391200e-004 ;
//	Mars
	AMASS[ 4]=1.0/3098703.590291;
	A[4][1]= -0.11018607714879824523;A[4][2]= -1.32759945030298299295;A[4][3]=-0.60588914048429142236;
	V[4][1]=  0.01448165305704756448;V[4][2]=  0.00024246307683646861;V[4][3]=-0.00028152072792433877;
//	Jupiter
	AMASS[ 5]=1.0/1047.348625;
	A[5][1]= -5.37970676855393644523;A[5][2]= -0.83048132656339789295;A[5][3]=-0.22482887442656542236;
	V[5][1]=  0.00109201259423733748;V[5][2]= -0.00651811661280738459;V[5][3]=-0.00282078276229867897;
//	Saturn
	AMASS[ 6]=1.0/3497.901768;
	A[6][1]=  7.89439068290953155477;A[6][2]=  4.59647805517127300705;A[6][3]= 1.55869584283189997764;
	V[6][1]= -0.00321755651650091552;V[6][2]=  0.00433581034174662541;V[6][3]= 0.00192864631686015503;
//	Uranus
	AMASS[ 7]=1.0/22902.981613;
	A[7][1]=-18.26540225387235944523;A[7][2]= -1.16195541867586999295;A[7][3]=-0.25010605772133802236;
	V[7][1]=  0.00022119039101561468;V[7][2]= -0.00376247500810884459;V[7][3]=-0.00165101502742994997;
//	Neptune
	AMASS[ 8]=1.0/19412.259776;
	A[8][1]=-16.05503578023336944523;A[8][2]=-23.94219155985470899295;A[8][3]=-9.40015796880239402236;
	V[8][1]=  0.00264276984798005548;V[8][2]= -0.00149831255054097759;V[8][3]=-0.00067904196080291327;
//	Pluto
	AMASS[ 9]=1.0/135836683.768617;
	A[9][1]=-30.48331376718383944523;A[9][2]= -0.87240555684104999295;A[9][3]= 8.91157617249954997764;
	V[9][1]=  0.00032220737349778078;V[9][2]= -0.00314357639364532859;V[9][3]=-0.00107794975959731297;
//	(MOON)   (DE431t@C)
	AMASS[10]=1.0/27068703.241203;
	A[10][1]= 1.197190565822129100e-001;A[10][2]= -9.278088688362892100e-001;A[10][3]= -4.026142782593574200e-001; 
	V[10][1]= 1.740504959425924500e-002;V[10][2]=  1.582898323168684600e-003;V[10][3]= 6.736803861947444400e-004 ;

//	f̃p[^̓ǂݍ݁BizS̃p[^j
	Minor_Planet(MinorPlanet);

//	f̃p[^Kvlzɑ(MAXN16̏ꍇ͏f͍ŏ5̂ݎ荞)
	for(M=11;M<=NBODY;M++){
	A[M][1]=MinorPlanet[M-11][1];
	A[M][2]=MinorPlanet[M-11][2];
	A[M][3]=MinorPlanet[M-11][3];
	V[M][1]=MinorPlanet[M-11][4];
	V[M][2]=MinorPlanet[M-11][5];
	V[M][3]=MinorPlanet[M-11][6];
	AMASS[M]=MinorPlanet[M-11][7];
	}

// f̃p[^𑾗znSɕύX邽߂ɁAz̃p[^B
	for(M=11;M<=NBODY;M++){
		for(N=1;N<=3;N++){
		A[M][N]=A[M][N]+A[0][N];
		V[M][N]=V[M][N]+V[0][N];
		}
	}

//	astronomical constants
	GAUSS =0.01720209895e0;
	GAUSS2=GAUSS*GAUSS;

//	planetary mass for DE431
	for ( M=0; M<= NBODY; M++){
		GMASS[M]=AMASS[M]*GAUSS2;
	}
}


//****************************************************************
// f̏lݒ@DE430/431̒`ɂ
// IPN Progress Report 42-196 February 15, 2014
// The Planetary and Lunar Ephemerides DE430 and DE431
//****************************************************************

void Minor_Planet(double MinorPlanet[67][8])
{
	int M,N;
double MinorPlanet_data[67][8]={																		
{	1	,	1.438681809676469747	,	-2.204373633189407045	,	-1.326397853361325874	,	0.008465406136316316	,	0.004684247977335608	,	0.000466157738595739	,	4.73E-10	},  //	1	Ceres*
{	2	,	0.203832272462290465	,	-3.209619436062307152	,	0.623843179079393351	,	0.008534313855651248	,	-0.000860659210123161	,	-0.000392901992572746	,	1.05E-10	},  //	2	Pallas*
{	4	,	0.182371836377417107	,	2.386628211277654010	,	0.924596062836265498	,	-0.010174496747119257	,	0.000041478190529952	,	0.001344157634155624	,	1.30E-10	},  //	4	Vesta*
{	7	,	1.892475267790300286	,	-0.848414748075139946	,	-0.157159319044464590	,	0.002786950314570632	,	0.011314057384917047	,	0.004975132577079665	,	7.22E-12	},  //	7	Iris*
{	324	,	1.398759064223541682	,	-1.287476729008325105	,	-0.669098428660833799	,	0.007164363244556328	,	0.009219958777618218	,	0.006857861727407507	,	4.69E-12	},  //	52	Bamberga*

{	3	,	0.461207259670432135	,	-3.006098959780790114	,	-0.580164049296942208	,	0.008395458298285176	,	0.003111908045571209	,	0.000273059675893248	,	1.22E-11	},  //	3	Juno
{	5	,	2.489297359488491956	,	1.036395265106434982	,	0.210563198822894787	,	-0.005569115604615741	,	0.007959732929200320	,	0.003113959705731406	,	1.27E-12	},  //	5	Astraea
{	6	,	1.339049495814490065	,	1.442775542206668815	,	0.079273672077323748	,	-0.008775983793258694	,	0.009426820472364830	,	0.003535716141864189	,	2.81E-12	},  //	6	Hebe
{	8	,	-2.119655892430383659	,	0.808466233981220750	,	0.533397871779012545	,	-0.005818098320155988	,	-0.008811943327809565	,	-0.002835330893491553	,	1.99E-12	},  //	8	Flora
{	9	,	-2.424658333778681119	,	-0.125325594242630484	,	0.185966267773321953	,	-0.001166914352512719	,	-0.009845348309999084	,	-0.004559667512580128	,	3.64E-12	},  //	9	Metis
{	10	,	2.444257569754775261	,	2.180591649726027814	,	1.162855082530954043	,	-0.005924505919570356	,	0.005979686441736038	,	0.002286438610925529	,	4.18E-11	},  //	10	Hygiea
{	11	,	-1.231933494613708824	,	-1.941584219024864888	,	-0.648652135887457293	,	0.010146729938442466	,	-0.004310578383941682	,	-0.002342316786027452	,	4.50E-12	},  //	11	Parthenope
{	13	,	1.110470035635196862	,	-1.956883630909689531	,	-1.669729176939996007	,	0.008850484510873332	,	0.004168221460244788	,	0.000793489279402694	,	6.07E-12	},  //	12	Egeria
{	14	,	2.968959552750401354	,	0.179534605878148124	,	-0.441493212476667563	,	0.000114431097969882	,	0.008313751393872647	,	0.003664818027075008	,	3.72E-12	},  //	13	Irene
{	15	,	-1.438397661546355177	,	2.001287639171841271	,	0.767257269566094968	,	-0.009735666014582665	,	-0.002981534818366074	,	-0.003694080871985814	,	1.58E-11	},  //	14	Eunomia
{	16	,	1.459069269212805553	,	-2.194286961057163143	,	-0.872045420720389042	,	0.008193866970882068	,	0.006328897736618455	,	0.002167069206448382	,	1.15E-11	},  //	15	Psyche
{	18	,	-2.742133025533653790	,	-0.012766315168109336	,	0.239819478175997858	,	-0.000996361773223022	,	-0.008953551423450837	,	-0.002237582813053089	,	6.79E-13	},  //	16	Melpomene
{	19	,	-2.421846633153337702	,	-1.337431649320276250	,	-0.581397545560000673	,	0.004769326689664416	,	-0.007520729608529603	,	-0.002981882787056496	,	3.50E-12	},  //	17	Fortuna
{	20	,	-0.446957693127368383	,	1.855382149831718674	,	0.778094121440758957	,	-0.012511421939296488	,	-0.002534666129817137	,	-0.001141856361378328	,	3.11E-13	},  //	18	Massalia
{	21	,	-0.401500082512939060	,	-2.034737356634178429	,	-0.878857903014080954	,	0.011859546440634965	,	-0.000138986487715931	,	-0.000750181020252093	,	8.55E-13	},  //	19	Lutetia
{	22	,	-1.360169904369056937	,	-2.672544709790108275	,	-1.131055224812947957	,	0.008015423798989894	,	-0.002573715371792212	,	-0.003469704484884123	,	4.06E-12	},  //	20	Kalliope
{	23	,	-1.381180931801666123	,	-2.177231877010123551	,	-0.869547456324116008	,	0.007230267698506810	,	-0.005803206866356805	,	-0.004345034311979445	,	6.41E-13	},  //	21	Thalia
{	24	,	-1.986326887180129397	,	1.713080040332319420	,	0.782177241944561841	,	-0.007376541658456220	,	-0.007515395858827745	,	-0.003291592430864249	,	6.40E-12	},  //	22	Themis
{	25	,	1.862187339641438788	,	-0.320827452239953126	,	0.370298833532256677	,	0.004047653066899725	,	0.012783082342996164	,	0.002077625994146512	,	2.45E-13	},  //	23	Phocaea
{	27	,	-1.260198559466741086	,	1.418639340820153416	,	0.648923808375896249	,	-0.010819473664968254	,	-0.006731978199858915	,	-0.002575089185167887	,	1.31E-12	},  //	24	Euterpe
{	28	,	-1.473796460584195778	,	1.739643135937173790	,	0.633933941012944979	,	-0.009328149750934787	,	-0.007427778551081034	,	-0.001181230605742862	,	9.89E-13	},  //	25	Bellona
{	29	,	-0.146988273583742862	,	-2.362796893883333915	,	-1.340108464209891492	,	0.010080728492092296	,	-0.000192196827316014	,	-0.000039573406685344	,	6.68E-12	},  //	26	Amphitrite
{	30	,	-2.606330961010526526	,	-0.080313889098223457	,	-0.119443301999580323	,	-0.000271687607297601	,	-0.009151555703778012	,	-0.004227028420836736	,	5.01E-13	},  //	27	Urania
{	31	,	-2.344572196151709420	,	-2.202248246583482949	,	-1.499371924448428484	,	0.004929226633590931	,	-0.003894954486494073	,	-0.005777736992660197	,	2.14E-11	},  //	28	Euphrosyne
{	41	,	2.186522806828394838	,	2.716000834079776549	,	0.352083724354172178	,	-0.006362487833486645	,	0.004588916254801226	,	0.000658460597293756	,	3.15E-12	},  //	29	Daphne
{	42	,	-2.311906318139493433	,	1.564709507254086418	,	1.081663757432244743	,	-0.005375422471534914	,	-0.006572477821943680	,	-0.002070451318821641	,	9.35E-13	},  //	30	Isis
{	45	,	-1.286740660767531352	,	-2.064333827345071093	,	-0.581533957673131763	,	0.009624183869937625	,	-0.005447390675875109	,	-0.002359148283535982	,	2.85E-12	},  //	31	Eugenia
{	51	,	2.325725710714735328	,	0.919631243406134669	,	0.195346323188101051	,	-0.004226342069996713	,	0.009366245889668433	,	0.002292473770765156	,	8.69E-13	},  //	32	Nemausa
{	52	,	1.630504392123616197	,	-2.807391275567590050	,	-1.120111554599330095	,	0.007545901962567781	,	0.004385628274804682	,	0.000681057876133087	,	8.37E-12	},  //	33	Europa
{	60	,	-2.053758095409557338	,	0.542618601186906857	,	0.167604428744862921	,	-0.005053755262744046	,	-0.010634893001978403	,	-0.003929518991233821	,	1.72E-13	},  //	34	Echo
{	63	,	-0.711507633861145239	,	-1.727049410575609123	,	-0.980245752936226511	,	0.011957874480153950	,	-0.003468676332191662	,	-0.001404339015793962	,	1.91E-13	},  //	35	Ausonia
{	65	,	-2.818818186481110377	,	-1.452785968979383169	,	-0.459547659952798004	,	0.005491212616137729	,	-0.007709765186399763	,	-0.002980907967655813	,	1.07E-11	},  //	36	Cybele
{	69	,	-2.731373586077875171	,	-0.173990396273168008	,	-0.091512829062557879	,	-0.000835829539403114	,	-0.010410309605217057	,	-0.002792056931756292	,	1.74E-12	},  //	37	Hesperia
{	78	,	-2.230308915264555658	,	-0.612004762065796459	,	-0.543275243058195634	,	0.001875816436270626	,	-0.009912063988588916	,	-0.005874203423004298	,	2.84E-13	},  //	38	Diana
{	94	,	1.217204321473684070	,	2.230213797067274850	,	1.349204301622864088	,	-0.009480919363038220	,	0.003964160607269546	,	0.002537794862740618	,	4.32E-12	},  //	39	Aurora
{	97	,	-1.909756234729403035	,	-2.678800550963929439	,	-0.452067580136410296	,	0.006291707122836601	,	-0.005039334023207890	,	-0.001538832193933371	,	3.49E-13	},  //	40	Klotho
{	98	,	-2.189380245469819020	,	0.226114692352493402	,	0.112525782901568755	,	-0.002121664740945849	,	-0.009612549934188979	,	-0.007843089126949381	,	8.26E-13	},  //	41	Ianthe
{	105	,	-2.150697286825749899	,	0.541875356226059646	,	-0.099139411741416952	,	-0.000933995664699450	,	-0.011865009015818844	,	-0.000510278917224607	,	1.26E-12	},  //	42	Artemis
{	111	,	-2.065235972301910916	,	-1.395192740371126838	,	-0.851171268109567225	,	0.005618108019220444	,	-0.008131544741012933	,	-0.003600368200049119	,	1.13E-13	},  //	43	Ate
{	135	,	-1.852065839438821637	,	-1.414537091163847737	,	-0.701764695699997887	,	0.008706738823410954	,	-0.006122907739411309	,	-0.002836580152272733	,	3.22E-13	},  //	44	Hertha
{	139	,	-2.286169743218249728	,	0.129793402866451107	,	0.113110508166727894	,	-0.001144921173599620	,	-0.010129177653436634	,	-0.006915213503334226	,	1.43E-12	},  //	45	Juewa
{	145	,	1.101693094201525502	,	2.046278461562542006	,	0.733533233415469499	,	-0.010477714288306773	,	0.002702890747395121	,	0.003883525044571004	,	2.55E-12	},  //	46	Adeona
{	187	,	1.552362680005133111	,	-1.667017286215509042	,	-1.224506107407864253	,	0.010026916904808853	,	0.004083994537401527	,	0.001832035781453411	,	3.18E-12	},  //	47	Lamberta
{	192	,	-2.180257484088014674	,	-1.605283294502194646	,	-1.009730329227873646	,	0.006837112554701223	,	-0.005228654546530322	,	-0.002756824225065406	,	8.49E-13	},  //	48	Nausikaa
{	194	,	1.495439006518376468	,	-1.277354772575368669	,	-0.299878060343942709	,	0.008680667325646010	,	0.010437900139680028	,	0.000134167930615169	,	9.20E-13	},  //	49	Prokne
{	216	,	-2.623737352933921407	,	-2.141208444909570296	,	-0.848460319932531903	,	0.005369324233200630	,	-0.005867957040039504	,	-0.000585039109819107	,	2.33E-12	},  //	50	Kleopatra
{	230	,	-2.280008375035697199	,	-0.880463965508790358	,	-0.645752311103840460	,	0.004331702501765179	,	-0.009223170407939286	,	-0.002470255504286102	,	5.95E-13	},  //	51	Athamantis
{	337	,	2.057440180433961707	,	-1.322162885949879740	,	-0.780976069801601058	,	0.005188028188451134	,	0.007591643038099468	,	0.004670779035477783	,	1.17E-13	},  //	53	Devosa
{	344	,	-1.436281403678767443	,	2.243805682206950092	,	2.055782461490350155	,	-0.006473875571808206	,	-0.004308997045040672	,	-0.001132197443002879	,	1.81E-12	},  //	54	Desiderata
{	354	,	0.400598302733801259	,	-2.845496057705452220	,	-0.363223167203308106	,	0.009411661670619676	,	-0.002169498446596223	,	-0.002270974488656075	,	5.36E-12	},  //	55	Eleonora
{	372	,	-2.501245479525921134	,	-1.473356596063249313	,	-2.186348442117559632	,	0.004414109643858683	,	-0.005694498088384558	,	-0.004127573934799787	,	5.90E-12	},  //	56	Palma
{	405	,	-1.680813989369112971	,	-0.720962772281693809	,	-0.636265292808031457	,	0.006053497060520836	,	-0.012004513735606900	,	-0.003193078939729851	,	1.88E-12	},  //	57	Thia
{	409	,	2.627942640819607600	,	0.032856722306475961	,	0.499378874814495721	,	-0.000121147420399894	,	0.009800913286716541	,	0.003214451046459611	,	2.78E-12	},  //	58	Aspasia
{	419	,	-0.832205073692585229	,	2.925043505666568677	,	1.070613454084370586	,	-0.007845381994993020	,	-0.002434064039560803	,	-0.001376245101202946	,	1.24E-12	},  //	59	Aurelia
{	451	,	1.259008304010221346	,	2.454041267595273634	,	0.690482754870751503	,	-0.009063543500060710	,	0.003448045666261337	,	0.004183420491116245	,	7.76E-12	},  //	60	Patientia
{	488	,	-2.067224538805315426	,	-1.883392328874813781	,	-0.393159264399483011	,	0.005745445324864604	,	-0.007721753293565463	,	-0.004781672638324677	,	6.47E-13	},  //	61	Kreusa
{	511	,	-2.160191561573574504	,	1.486363108760649254	,	1.096959097247329984	,	-0.007390695920479255	,	-0.007779023504823501	,	-0.000485540781565076	,	1.76E-11	},  //	62	Davida
{	532	,	-0.293159404090669762	,	-2.481691048455131110	,	-0.725934583722743554	,	0.010153432932361773	,	-0.002073902764508174	,	-0.003634391919195946	,	3.15E-12	},  //	63	Herculina
{	554	,	1.567515331928776900	,	-1.756839671087627286	,	-0.730145653545691942	,	0.007168202681128191	,	0.007126474516266886	,	0.003646321528209388	,	9.29E-13	},  //	64	Peraga
{	654	,	2.454317123300634673	,	-1.156415934845627769	,	0.311816838296415377	,	0.001774157409192030	,	0.007979676971587255	,	0.004592146292516224	,	1.21E-12	},  //	65	Zelinda
{	704	,	2.462835232264114715	,	-0.115048121589235539	,	0.784219288788080227	,	-0.001309568805636822	,	0.010348987192429257	,	0.004812522889055394	,	1.78E-11	},  //	66	Interamnia
{	747	,	-0.834902081339142454	,	2.059697173467183617	,	0.613292775285328884	,	-0.012134738848543374	,	-0.002004140070559451	,	0.002575815432470426	,	2.10E-12	},  //	67	Winchester
};																		

	for(M=0;M<67;M++){
		for(N=0;N<8;N++){
			MinorPlanet[M][N]=MinorPlanet_data[M][N];
		}
	}

}

//*********************************************************************
// QNb^@ɏlvZ[` (12step̌vZ)
// m[oXCDE (V3.21 1997/11/03)ڐA܂B
//*********************************************************************

void ni_Runge_Kutta_exec(double DAY,double EPOCH,int NBODY,double GMASS[MAXN] ,double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4])
{
	int i,k,n,I;
	double A,V;

//	f̏ʒǔvZ 
	for(i=0;i<NIORD;i++){
//		printf("f̏ʒu(%d)\n",i+1);
    I=i+0;  // lɂiڂ̉x̌vZ
	PERN ( NBODY, I, GMASS , PER, CD, VL);
		for(k=0;k<MAX_NI;k++){
			for(n=1;n<=3;n++){
				VL[i+1][k][n]=VL[i+0][k][n]+PER[i+0][k][n]*DAY/2.0;
				CD[i+1][k][n]=CD[i+0][k][n]+VL[i+0][k][n]*DAY/2.0;
			}
		}
    I=i+1;  // lɂ2iڂ̉x̌vZ
	PERN ( NBODY, I, GMASS , PER, CD, VL);

		for(k=0;k<MAX_NI;k++){
			for(n=1;n<=3;n++){
				VL[i+2][k][n]=VL[i+0][k][n]+PER[i+1][k][n]*DAY/2.0;
				CD[i+2][k][n]=CD[i+0][k][n]+VL[i+1][k][n]*DAY/2.0;
			}
		}
    I=i+2;  // lɂ3iڂ̉x̌vZ
	PERN ( NBODY, I, GMASS , PER, CD, VL);

	for(k=0;k<MAX_NI;k++){
			for(n=1;n<=3;n++){
				VL[i+3][k][n]=VL[i+0][k][n]+PER[i+2][k][n]*DAY;
				CD[i+3][k][n]=CD[i+0][k][n]+VL[i+2][k][n]*DAY;
			}
		}
    I=i+3;  // lɂ3iڂ̉x̌vZ
	PERN ( NBODY, I, GMASS , PER, CD, VL);

		for(k=0;k<MAX_NI;k++){
			for(n=1;n<=3;n++){
				A =    PER[i+0][k][n];
				A+=2.0*PER[i+1][k][n];
				A+=2.0*PER[i+2][k][n];
				A+=    PER[i+3][k][n];
				A/=6.0;

				V =    VL[i+0][k][n];
				V+=2.0*VL[i+1][k][n];
				V+=2.0*VL[i+2][k][n];
				V+=    VL[i+3][k][n];
				V/=6.0;

				VL[i+1][k][n]=VL[i][k][n]+A*DAY;
				CD[i+1][k][n]=CD[i][k][n]+V*DAY;
			}
		}

	}

    I=i+1;  // lɂiڂ̉x̌vZ
	PERN ( NBODY, I, GMASS , PER, CD, VL);

	return;
}

//*********************************************************************
//	A_X̐lϕ@W̌vZ
// m[oXCDE (V3.21 1997/11/03)ڐA܂B
//*********************************************************************

void ni_Adams_init(double APcf[ADAMS], double ACcf[ADAMS] )
{
	int i,j;

//	W̌vZ 
	APcf[0]=ACcf[0]=1.0;
	for(i=1;i<ADAMS;i++){
		APcf[i]=1.0;
		for(j=i;j>0;j--)APcf[i]-=APcf[j-1]/(double)(i-j+2);
		ACcf[i]=0.0;
		for(j=i;j>0;j--)ACcf[i]-=ACcf[j-1]/(double)(i-j+2);
	}

}


//*********************************************************************
//	A_X̐lϕ@(\)
// m[oXCDE (V3.21 1997/11/03)ڐA܂B
//*********************************************************************

void ni_Predict_Adams(double h,int p,double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double APcf[ADAMS] )
{
	int j,k,m,n;
	double A,V;
	double Adif[NIORD][NIORD],Vdif[NIORD][NIORD];

	for(k=0;k<MAX_NI;k++){
		for(n=1;n<=3;n++){
			for(j=0;j<NIORD;j++)Adif[0][j]=PER[(p+j+1)%NIDAY][k][n];
			for(j=1;j<NIORD;j++)for(m=0;m<(NIORD-j);m++){
				Adif[j][m]=Adif[j-1][m]-Adif[j-1][m+1];
			}
			A=0.0;
			for(j=0;j<NIORD;j++)A+=APcf[j]*Adif[j][0];
			VL[p][k][n]=VL[(p+1)%NIDAY][k][n]+A*h;
		}
	}
	for(k=0;k<MAX_NI;k++){
		for(n=1;n<=3;n++){
			for(j=0;j<NIORD;j++)Vdif[0][j]=VL[(p+j+1)%NIDAY][k][n];
			for(j=1;j<NIORD;j++)for(m=0;m<(NIORD-j);m++){
				Vdif[j][m]=Vdif[j-1][m]-Vdif[j-1][m+1];
			}
			V=0.0;
			for(j=0;j<NIORD;j++)V+=APcf[j]*Vdif[j][0];
			CD[p][k][n]=CD[(p+1)%NIDAY][k][n]+V*h;
		}
	}
	return;
}

//*********************************************************************
//	A_X̐lϕ@(C)
// m[oXCDE (V3.21 1997/11/03)ڐA܂B
//*********************************************************************
void ni_Correct_Adams(double h,int p,double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double ACcf[ADAMS])
{
	int j,k,m,n;
	double A,V;
	double Adif[NIORD][NIORD],Vdif[NIORD][NIORD];

	for(k=0;k<MAX_NI;k++){
		for(n=1;n<=3;n++){
			for(j=0;j<NIORD;j++)Adif[0][j]=PER[(p+j)%NIDAY][k][n];
			for(j=1;j<NIORD;j++)for(m=0;m<(NIORD-j);m++){
				Adif[j][m]=Adif[j-1][m]-Adif[j-1][m+1];
			}
			A=0.0;
			for(j=0;j<NIORD;j++)A+=ACcf[j]*Adif[j][0];
			VL[p][k][n]=VL[(p+1)%NIDAY][k][n]+A*h;
		}
	}
	for(k=0;k<MAX_NI;k++){
		for(n=1;n<=3;n++){
			for(j=0;j<NIORD;j++)Vdif[0][j]=VL[(p+j)%NIDAY][k][n];
			for(j=1;j<NIORD;j++)for(m=0;m<(NIORD-j);m++){
				Vdif[j][m]=Vdif[j-1][m]-Vdif[j-1][m+1];
			}
			V=0.0;
			for(j=0;j<NIORD;j++)V+=ACcf[j]*Vdif[j][0];
			CD[p][k][n]=CD[(p+1)%NIDAY][k][n]+V*h;
		}
	}
	return;
}

//*********************************************************************
//	A_X̐lϕ@^s
// m[oXCDE (V3.21 1997/11/03)ڐA܂B
//*********************************************************************
int ni_Adams_exec(double t,int p,int NBODY,double GMASS[MAXN],double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4],double APcf[ADAMS],double ACcf[ADAMS])	// return:̐ϕ[Ñ|C^[ 
{
	int i;
	double h;
	h=t/(double)NISTP;

	for(i=0;i<NISTP;i++){
		if(p>0)	p--;
		else	p=NIDAY-1;
		ni_Predict_Adams( h, p, PER, CD, VL, APcf);
		PERN ( NBODY, p, GMASS , PER, CD, VL);
		ni_Correct_Adams( h, p, PER, CD, VL, ACcf);
		PERN ( NBODY, p, GMASS , PER, CD, VL);
	}
	return p;
}

//****************************************************************
// m̐ϕɂx̌vZ	
//****************************************************************

 	void PERN(int NBODY, int I,double GMASS[MAXN] ,double PER[NIDAY][MAXN][4],double CD[NIDAY][MAXN][4],double VL[NIDAY][MAXN][4])
{
	double DIRECT[MAXN][MAXN][4],PER0[MAXN][4],PER1[MAXN][4];
	double CDD[MAXN][MAXN][4],CD1[MAXN][MAXN],CD2[MAXN][MAXN],c;
	double U[MAXN][MAXN],SU[MAXN];
	double a10,a11,a12,a13,a14,a15,a16,a16_0,a17;
	double a20[4],a21[4],a22[4],a30[4];
	int		i,j,N;	
	
	c=299792.458*24.0*3600.0/1.495978070e8; // Light Speed (AU/DAY)

//	j[g͊wɂx̌vZ(znS)

	for ( i=0; i<=NBODY; i++){
		for ( j=0; j<=NBODY; j++){
			if(i!=j){
				for(N=1;N<=3;N++)CDD[i][j][N]=CD[I][j][N]-CD[I][i][N];
				CD2[i][j]=MULT(CDD[i][j],CDD[i][j]);
				CD1[i][j]=sqrt(CD2[i][j]);
				U[i][j]=GMASS[j]/CD1[i][j];
				for(N=1;N<=3;N++)DIRECT[i][j][N]=CDD[i][j][N]*U[i][j]/CD2[i][j];
			}
		}
	}

		for (i=0;i<=NBODY;i++){
			for(N=1;N<=3;N++)PER0[i][N]=0.0;
			SU[i]=0.0;
			for( j=0;j<=NBODY;j++){
				if(i  !=  j){
				SU[i]=SU[i]+U[i][j];
				for(N=1;N<=3;N++)PER0[i][N]=PER0[i][N]+DIRECT[i][j][N];
				}
		}
	}
		for (i=0;i<=NBODY;i++){
			for(N=1;N<=3;N++)PER1[i][N]=0.0;
			for( j=11;j<=NBODY;j++){
				if(i  !=  j){
				for(N=1;N<=3;N++)PER1[i][N]=PER1[i][N]+DIRECT[i][j][N];
				}
		}
	}

//PER1[][][]̓j[g͊w̉x
/*
for (i=0;i<=NBODY;i++){
			for(N=1;N<=3;N++)PER[I][i][N]=0.0;
			for( j=0;j<=NBODY;j++){
				if(i  !=  j){
				for(N=1;N<=3;N++)PER[I][i][N]=PER[I][i][N]+DIRECT[i][j][N];
				}
		}
	}
*/
// ΐ_x@P

		for (i=0;i<=NBODY;i++){
		for( j=0;j<=NBODY;j++){
			if(i  !=  j){
			a11=-4.0*SU[i];
			a12=-1.0*SU[j];
			a13= MULT(VL[I][i],VL[I][i]);
			a14= 2.0*MULT(VL[I][j],VL[I][j]);
			a15= -4.0* MULT(VL[I][i],VL[I][j]);
			a16_0=MULT(CDD[j][i],VL[I][j])/CD1[j][i];
			a16=-1.5*a16_0*a16_0;
			a17= 0.5* MULT(CDD[i][j],PER0[j]);
			a10=(1.0+(a11+a12+a13+a14+a15+a16+a17)/(c*c));
			for(N=1;N<=3;N++)DIRECT[i][j][N]=DIRECT[i][j][N]*a10;
			}
		}
		}
	
		for (i=0;i<=NBODY;i++){
			for(N=1;N<=3;N++)PER[I][i][N]=0.0;
			for( j=0;j<=NBODY;j++){
				if(i  !=  j){
				for(N=1;N<=3;N++)PER[I][i][N]=PER[I][i][N]+DIRECT[i][j][N];
				}
		}
	}

// ΐ_x@Q

		for (i=0;i<=NBODY;i++){
			for( j=0;j<=NBODY;j++){
				if(i  !=  j){
					for(N=1;N<=3;N++)a21[N]=(4.0*VL[I][i][N]-3.0*VL[I][j][N]);
					for(N=1;N<=3;N++){
						a22[N]=MULT(CDD[j][i],a21);
						a20[N]=U[i][j]/CD2[i][j]*a22[N]*(VL[I][i][N]-VL[I][j][N]);
						PER[I][i][N]=PER[I][i][N]+a20[N]/(c*c);
					}			
				}
		}
	}

// ΐ_x@R

		for (i=0;i<=NBODY;i++){
			for( j=0;j<=NBODY;j++){
				if(i  !=  j){
					for(N=1;N<=3;N++){
						a30[N]=3.5*U[i][j]*PER0[j][N];
						PER[I][i][N]=PER[I][i][N]+a30[N]/(c*c);
					}			
				}
		}
	}
		

}
/*******************************************************************************/
/*                      ̌vZ                                             */
/*                                                                             */
/*               gpԂnW(LST)ȂF LST=1                         */
/*               gpԂnώ(LMT)ȂF LST=0                         */
/*******************************************************************************/

void Calendar( double juday, double *year,double *month,double *day,double *hour,int LST,double longitude)
{
	double flag,Z,Alfa,A,B,C,D,E,F,Day0;
	
	flag = 1;

	if (longitude<0 ){
		longitude = - longitude;
		flag=-1.0;
	}
	
	if (LST==1) juday =  juday +  flag*(double)(int)(longitude /15.0+0.5)/24.0;
		else    juday =  juday +  flag*longitude /15.0/24.0	;
		
	juday = juday + 0.5;
	Z = (double)(int)(juday);
	F = juday - Z;

	if (Z < 2299161.0) A = Z;
		else { 
			Alfa = (double)(int) ((Z - 1867216.25)/36524.25);
			A = Z + 1 + Alfa - (double)(int) (Alfa/4.0);}

	B = A + 1524;
	C = (double)(int) ((B-122.1)/365.25);
	D = (double)(int) (365.25 * C);
	E = (double)(int) ((B-D)/30.6001);

	Day0 = B - D - (double)(int)(30.60001*E) + F;
	*day = (double)(int)(Day0);
	*hour= F*24.0;
	if(E<14.0) *month = E-1.0;
	if(E==14.0 || E==15.0)	 *month = E- 13.0;
	if(*month>2.0) *year=C-4716;
	if(*month==1.0 || *month==2.0) *year = C - 4715;
}
